package dev.kske.chess.game;

import dev.kske.chess.board.Board;
import dev.kske.chess.board.Piece.Color;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>Player.java</strong><br>
 * Created: <strong>06.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public abstract class Player {

	protected Game		game;
	protected Board		board;
	protected Color		color;
	protected String	name;

	public Player(Color color) {
		this.color = color;
	}

	public abstract void requestMove();

	public abstract void cancelMove();

	public abstract void disconnect();

	public Game getGame() { return game; }

	public void setGame(Game game) {
		this.game	= game;
		board		= game.getBoard();
	}

	public Board getBoard() { return board; }

	public void setBoard(Board board) { this.board = board; }

	public Color getColor() { return color; }

	public void setColor(Color color) { this.color = color; }

	public String getName() { return name; }

	public void setName(String name) { this.name = name; }
}
