package dev.kske.chess.ui;

import java.awt.Dimension;

import javax.swing.JLayeredPane;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>BoardPane.java</strong><br>
 * Created: <strong>08.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class BoardPane extends JLayeredPane {

	private static final long serialVersionUID = -5415058382478806092L;

	private final BoardComponent	boardComponent;
	private final OverlayComponent	overlayComponent;

	private int tileSize;

	public BoardPane() {
		boardComponent		= new BoardComponent(this);
		overlayComponent	= new OverlayComponent(this);
		setLayer(overlayComponent, 1);
		setLayout(null);

		add(boardComponent);
		add(overlayComponent);

		tileSize = 60;
		setSize(getPreferredSize());
	}

	@Override
	public Dimension getPreferredSize() { return new Dimension(480, 480); }

	public BoardComponent getBoardComponent() { return boardComponent; }

	public OverlayComponent getOverlayComponent() { return overlayComponent; }

	public int getTileSize() { return tileSize; }
}
