package dev.kske.chess.test;

import static org.junit.Assert.assertEquals;

import java.util.Arrays;
import java.util.List;
import java.util.stream.IntStream;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import dev.kske.chess.board.Position;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>PositionTest.java</strong><br>
 * Created: <strong>24.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
class PositionTest {

	List<Position>	positions;
	List<String>	sans;

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeEach
	void setUp() throws Exception {
		positions	= Arrays.asList(new Position(0, 0), new Position(7, 7), new Position(0, 7), new Position(7, 0));
		sans		= Arrays.asList("a8", "h1", "a1", "h8");
	}

	/**
	 * Test method for
	 * {@link dev.kske.chess.board.Position#fromSAN(java.lang.String)}.
	 */
	@Test
	void testFromSAN() {
		IntStream.range(0, positions.size())
			.forEach(i -> assertEquals(positions.get(i), Position.fromSAN(sans.get(i))));
	}

	/**
	 * Test method for {@link dev.kske.chess.board.Position#toSAN()}.
	 */
	@Test
	void testToSAN() {
		IntStream.range(0, positions.size()).forEach(i -> assertEquals(sans.get(i), positions.get(i).toSAN()));
	}

}
